#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ui unsigned int
#define ull unsigned long long
#define int long long

vector<int> init(string& a) {
    vector<int> tek;
    for (int i = sz(a) - 1; i >= 0; i--) {
        tek.pb(a[i] - '0');
    }
    return tek;
}

void print(vector<int>& a) {
    for (int i : a) {
        cout << i;
    }
    cout << " ";
}

vector<int> sum(vector<int>& a, vector<int>& b) {
    int tek;
    vector<int> ans;
    for (int i = 0; i < max(sz(a), sz(b)); ++i) {
        int val1 = 0, val2 = 0;
        if (i < sz(a)) {
            val1 = a[i];
        }
        if (i < sz(b)) {
            val2 = b[i];
        }
        ans.pb(max(val1, val2));
    }
    return ans;
}

vector<int> pr(vector<int>& a, vector<int>& b) {
    vector<int> ans(1e6 + 100);
    for (int i = 0; i < sz(a); ++i) {
        for (int j = 0; j < sz(b); ++j) {
            ans[i + j] = max(ans[i + j], min(a[i], b[j]));
        }
    }
    while (!ans.empty() && ans.back() == 0) {
        ans.pop_back();
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    string a1, b1;
    cin >> a1 >> b1;
    vector<int> a = init(a1), b = init(b1);
    vector<int> ans1 = sum(a, b);
    reverse(all(ans1));
    print(ans1);
    vector<int> ans2 = pr(a, b);
    reverse(all(ans2));
    print(ans2);
    return 0;
}
