#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ui unsigned int
#define ull unsigned long long
#define int long long

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<int>> g(n + 1);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        g[l].pb(r);
        g[r].pb(l);
    }
    set<pair<int, int>> s;
    vector<int> dist(n + 1, -1);
    for (int i = 0; i < k; ++i) {
        int p, h;
        cin >> p >> h;
        dist[p] = h;
        s.insert({h, p});
    }
    while (!s.empty()) {
        auto it1 = s.end();
        it1--;
        auto it = *it1;
        s.erase(it1);
        if (it.first == 0) {
            continue;
        }
        for (auto v : g[it.second]) {
            if (dist[v] < it.first - 1) {
                s.erase({dist[v], v});
                dist[v] = it.first - 1;
                s.insert({dist[v], v});
            }
        }
    }
    vector<int> ans;
    for (int i = 1; i <= n; ++i) {
        if (dist[i] >= 0) {
            ans.pb(i);
        }
    }
    cout << sz(ans) << "\n";
    for (int i : ans) {
        cout << i << " ";
    }
    return 0;
}
