#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ui unsigned int
#define ull unsigned long long
#define int long long

int n;
vector<int> p;

int find_p(int v) {
    if (v == p[v]) {
        return v;
    }
    return v = find_p(p[v]);
}

void un(int l, int r) {
    l = find_p(l);
    r = find_p(r);
    p[l] = r;
}

struct line {
    ld a, b, c;

    line() {}

    line(ld a1, ld b1, ld c1) {
        a = a1, b = b1, c = c1;
    }

    pair<ld, ld> find_p(line l) {
        ld y = (l.c * a - c * l.a) / (b * l.a - l.b * a);
        ld x = (l.c * b - c * l.b) / (a * l.b - b * l.a);
        return {x, y};
    }
};

ld dist(pair<ld, ld> x, pair<ld, ld> y) {
    return sqrt((x.first - y.first) * (x.first - y.first) + (x.second - y.second) * (x.second - y.second));
}

struct triple{
    ld zn;
    int l, r;
};

bool comp(triple x, triple y) {
    return x.zn < y.zn;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    p.resize(n);
    vector<pair<ld, ld>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    vector<pair<ld, ld>> f;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            f.pb({a[i].second - a[j].second, a[j].first - a[i].first});
        }
    }
    ld ans = 1e18;
    for (auto k : f) {
        pair<int, int> s = {-k.second, k.first};
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
        vector<triple> zap;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                line l1 = line(k.first, k.second, -(k.first * a[i].first + k.second * a[i].second));
                line l2 = line(s.first, s.second, -(s.first * a[j].first + s.second * a[j].second));
                auto v = l1.find_p(l2);
                zap.pb({dist(v, a[i]) + dist(v, a[j]), i, j});
            }
        }
        sort(all(zap), comp);
        ld sum = 0;
        for (auto it : zap) {
            if (find_p(it.l) != find_p(it.r)) {
                un(it.l, it.r);
                sum += it.zn;
            }
        }
        ans = min(ans, sum);
    }
    cout.precision(25);
    cout << std::fixed << ans;
    return 0;
}
