#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define ll long long
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ui unsigned int
#define ull unsigned long long
#define int long long

int n;

struct line {
    ld a, b, c;

    line() {}

    line(ld a1, ld b1, ld c1) {
        a = a1, b = b1, c = c1;
    }

    pair<ld, ld> find_p(line l) {
        ld y = (l.c * a - c * l.a) / (b * l.a - l.b * a);
        ld x = (l.c * b - c * l.b) / (a * l.b - b * l.a);
        return {x, y};
    }
};

ld dist(pair<ld, ld> x, pair<ld, ld> y) {
    return sqrt((x.first - y.first) * (x.first - y.first) + (x.second - y.second) * (x.second - y.second));
}

struct triple{
    ld zn;
    int l, r;
};

bool comp(triple x, triple y) {
    return x.zn < y.zn;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    int kol = 1;
    for (int i = 1; i <= n; ++i) {
        kol *= i;
    }
    vector<pair<ld, ld>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    ld ans = 1e18;
    vector<int> p;
    for (int i = 0; i < n; ++i) {
        p.pb(i);
    }
    vector<pair<ld, ld>> f;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            f.pb({a[i].second - a[j].second, a[j].first - a[i].first});
        }
    }
    for (auto k : f) {
        int kol1 = kol;
        pair<ld, ld> s = {-k.second, k.first};
        while (kol1--) {
            ld sum = 0;
            for (int i = 1; i < n; ++i) {
                line l1 = {k.first, k.second, -(k.first * a[p[i - 1]].first + k.second * a[p[i - 1]].second)};
                line l2 = {s.first, s.second, -(s.first * a[p[i]].first + s.second * a[p[i]].second)};
                auto v = l1.find_p(l2);
                sum += dist(v, a[p[i - 1]]) + dist(v, a[p[i]]);
            }
            ans = min(ans, sum);
            next_permutation(all(p));
        }
    }
    cout.precision(20);
    cout << std::fixed << ans;
    return 0;
}